/*******************************************************************************
 * Copyright (c) 2004, 2005 IBM Corporation.
 * All rights reserved. 
 *******************************************************************************/
package com.ibm.samplesgallery.servlets;

import java.io.IOException;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.ibm.samplegallery.internal.BookmarkTopic;
import com.ibm.samplegallery.internal.BookmarksData;
import com.ibm.samplegallery.internal.GalleryConstants;
import com.ibm.samplegallery.internal.ServletResources;
import com.ibm.samplegallery.internal.UrlUtil;
import com.ibm.samplegallery.internal.WebappPreferences;

/**
 * Class to handle the display of the bookmark tab
 */
public class BookmarkNavigator extends HttpServlet implements GalleryConstants {
	public void doGet(HttpServletRequest req, HttpServletResponse res)
	throws ServletException, IOException {
			processRequest(req, res);
	}
	
	public void doPost(HttpServletRequest req, HttpServletResponse res)
	throws ServletException, IOException {
		processRequest(req, res);
	}
	
	public void processRequest(HttpServletRequest req, HttpServletResponse resp)
		throws ServletException, IOException {
		resp.setContentType("text/html;charset=UTF-8"); //$NON-NLS-1$
		BookmarksData data = new BookmarksData(req, resp);
		WebappPreferences prefs = data.getPrefs();

		StringBuffer html = new StringBuffer();
		html.append("<html>\n"); //$NON-NLS-1$
		html.append("<head>\n"); //$NON-NLS-1$
		html.append("<meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n"); //$NON-NLS-1$
		html.append("<meta http-equiv=\"Pragma\" content=\"no-cache\">\n"); //$NON-NLS-1$
		html.append("<meta http-equiv=\"Expires\" content=\"-1\">\n"); //$NON-NLS-1$
		
		html.append("<style type=\"text/css\">\n"); //$NON-NLS-1$
		html.append("BODY {\n"); //$NON-NLS-1$
		html.append("background-color: " + prefs.getViewBackground() + ";\n"); //$NON-NLS-1$ //$NON-NLS-2$
		html.append("font: " + prefs.getViewFont() + ";\n"); //$NON-NLS-1$ //$NON-NLS-2$
		html.append("margin-top:5px;\n"); //$NON-NLS-1$
		html.append("margin-left:5px;\n"); //$NON-NLS-1$
		html.append("padding:0;\n"); //$NON-NLS-1$
		html.append("border:0;\n"); //$NON-NLS-1$
		html.append("cursor:default;\n"); //$NON-NLS-1$
		html.append("}\n"); //$NON-NLS-1$
		html.append("\n"); //$NON-NLS-1$
		html.append("A {\n"); //$NON-NLS-1$
		html.append("text-decoration:none;\n"); //$NON-NLS-1$
		html.append("color:WindowText;\n"); //$NON-NLS-1$
		html.append("padding:0px;\n"); //$NON-NLS-1$
		html.append("white-space: nowrap;\n"); //$NON-NLS-1$
		html.append("}\n"); //$NON-NLS-1$
		html.append("\n"); //$NON-NLS-1$
		html.append("A:hover {\n"); //$NON-NLS-1$
		html.append("text-decoration:underline;\n"); //$NON-NLS-1$
		html.append("}\n"); //$NON-NLS-1$
		html.append("\n"); //$NON-NLS-1$
		html.append("IMG {\n"); //$NON-NLS-1$
		html.append("border:0px;\n"); //$NON-NLS-1$
		html.append("margin:0px;\n"); //$NON-NLS-1$
		html.append("padding:0px;\n"); //$NON-NLS-1$
		html.append("margin-right:4px;\n"); //$NON-NLS-1$
		html.append("}\n"); //$NON-NLS-1$
		html.append("\n"); //$NON-NLS-1$
		html.append("TABLE {\n"); //$NON-NLS-1$
		html.append("background-color: " + prefs.getViewBackground() + ";\n"); //$NON-NLS-1$ //$NON-NLS-2$
		html.append("font: " + prefs.getViewFont() + ";\n"); //$NON-NLS-1$ //$NON-NLS-2$
		html.append("width:100%;\n"); //$NON-NLS-1$
		html.append("}\n"); //$NON-NLS-1$
		html.append("\n"); //$NON-NLS-1$
		html.append(".list {\n"); //$NON-NLS-1$
		html.append("background-color: " + prefs.getViewBackground() + ";\n"); //$NON-NLS-1$ //$NON-NLS-2$
		html.append("padding:2px;\n"); //$NON-NLS-1$
		html.append("}\n"); //$NON-NLS-1$
		html.append("\n"); //$NON-NLS-1$
		html.append(".sectiontitle {\n"); //$NON-NLS-1$
		html.append("background-color: " + prefs.getToolbarBackground() + ";\n"); //$NON-NLS-1$ //$NON-NLS-2$
		html.append("font-weight:bold;\n"); //$NON-NLS-1$
		html.append("margin-top:7px;\n"); //$NON-NLS-1$
		html.append("}\n"); //$NON-NLS-1$
		html.append("\n"); //$NON-NLS-1$
		html.append(".active {\n"); //$NON-NLS-1$
		html.append("background:Highlight;\n"); //$NON-NLS-1$
		html.append("color:HighlightText;\n"); //$NON-NLS-1$
		html.append("}\n"); //$NON-NLS-1$
		html.append("\n"); //$NON-NLS-1$
		html.append(".label {\n"); //$NON-NLS-1$
		html.append("margin-left:4px;\n"); //$NON-NLS-1$
		html.append("}\n"); //$NON-NLS-1$
		html.append("\n"); //$NON-NLS-1$
		html.append("#menu {\n"); //$NON-NLS-1$
		html.append("position:absolute;\n"); //$NON-NLS-1$
		html.append("display:none;\n"); //$NON-NLS-1$
		html.append("background:" + prefs.getToolbarBackground() + ";\n"); //$NON-NLS-1$ //$NON-NLS-2$
		html.append("border:2px outset;\n"); //$NON-NLS-1$
		html.append("padding:2px 0px;\n"); //$NON-NLS-1$
		html.append("}\n"); //$NON-NLS-1$
		html.append("\n"); //$NON-NLS-1$
		html.append(".selectedMenuItem {\n"); //$NON-NLS-1$
		html.append("background:Highlight;\n"); //$NON-NLS-1$
		html.append("color:HighlightText;\n"); //$NON-NLS-1$
		html.append("padding-left:10px;\n"); //$NON-NLS-1$
		html.append("padding-right:10px;\n"); //$NON-NLS-1$
		html.append("}\n"); //$NON-NLS-1$
		html.append("\n"); //$NON-NLS-1$
		html.append(".unselectedMenuItem {\n"); //$NON-NLS-1$
		html.append("background:" + prefs.getToolbarBackground() + ";\n"); //$NON-NLS-1$ //$NON-NLS-2$
		html.append("color:WindowText;\n"); //$NON-NLS-1$
		html.append("padding-left:10px;\n"); //$NON-NLS-1$
		html.append("padding-right:10px;\n"); //$NON-NLS-1$
		html.append("}\n"); //$NON-NLS-1$
		html.append("\n"); //$NON-NLS-1$
		html.append(".score {\n"); //$NON-NLS-1$
		html.append("padding-right:5px;\n"); //$NON-NLS-1$
		html.append("}\n"); //$NON-NLS-1$
		html.append("</style>\n"); //$NON-NLS-1$
		
		html.append("<base target=\"Main\">\n"); //$NON-NLS-1$
		html.append("<script language=\"JavaScript\"  src=\"scripts/list.js\">\n"); //$NON-NLS-1$
		html.append("</script>\n"); //$NON-NLS-1$
		
		html.append("<script language=\"JavaScript\">\n"); //$NON-NLS-1$
		html.append("function removeBookmark()\n"); //$NON-NLS-1$
		html.append("{\n"); //$NON-NLS-1$
		html.append("if (!active)\n"); //$NON-NLS-1$
		html.append("return false;\n"); //$NON-NLS-1$
		html.append("\n"); //$NON-NLS-1$
		html.append("var bookmark = active;\n"); //$NON-NLS-1$
		html.append("active = null;\n"); //$NON-NLS-1$
		html.append("\n"); //$NON-NLS-1$
		html.append("var url = bookmark.href;\n"); //$NON-NLS-1$
		html.append("\n"); //$NON-NLS-1$
		html.append("var title = bookmark.title;\n"); //$NON-NLS-1$
		html.append("if (title == null || title == \"\")\n"); //$NON-NLS-1$
		html.append("title = url;\n"); //$NON-NLS-1$
		html.append("\n"); //$NON-NLS-1$
		html.append("window.location.replace(\"BookmarkNavigator?operation=remove&bookmark=\"+encodeURIComponent(url)+\"&title=\"+encodeURIComponent(title));\n"); //$NON-NLS-1$
		html.append("return true;\n"); //$NON-NLS-1$
		html.append("}\n"); //$NON-NLS-1$
		
		html.append("function removeAllBookmarks()\n"); //$NON-NLS-1$
		html.append("{\n"); //$NON-NLS-1$
		html.append("hidePopupMenu();\n"); //$NON-NLS-1$
		String removeAllWarning = ServletResources.getString(I18N.BOOKMARK_REMOVE_ALL_WARNING, req);
		html.append("if(!confirm(\"" + removeAllWarning + "\"))\n"); //$NON-NLS-1$ //$NON-NLS-2$
		html.append("return true;\n"); //$NON-NLS-1$
		html.append("window.location.replace(\"BookmarkNavigator?operation=removeAll\");\n"); //$NON-NLS-1$
		html.append("return true;\n"); //$NON-NLS-1$
		html.append("}\n"); //$NON-NLS-1$
		
		html.append("</script>\n"); //$NON-NLS-1$
		
		
		html.append("</head>\n"); //$NON-NLS-1$
		
		html.append("<body>\n"); //$NON-NLS-1$
		if(data.getBookmarks().length == 0) {
			html.append(ServletResources.getString(I18N.BOOKMARK_NO_BOOKMARK, req));
		} else {
			html.append("<table id='list'  cellspacing='0' >\n"); //$NON-NLS-1$
			BookmarkTopic[] bookmarks = data.getBookmarks();
			for (int i=0; i<bookmarks.length; i++) 
			{
				html.append("<tr class='list' id='r" + i + "'>\n"); //$NON-NLS-1$ //$NON-NLS-2$
				html.append("<td align='left' class='label' nowrap>\n"); //$NON-NLS-1$
				html.append("<img src=\"" + prefs.getImagesDirectory() + "/topic.gif\" alt=\"\">\n"); //$NON-NLS-1$ //$NON-NLS-2$

				html.append("<a id='a" + i + "'\n"); //$NON-NLS-1$ //$NON-NLS-2$
				html.append("href='" + bookmarks[i].getHRef() + "'\n"); //$NON-NLS-1$ //$NON-NLS-2$
				html.append("onmouseover=\"showStatus(event);return true;\"\n"); //$NON-NLS-1$
				html.append("onmouseout=\"clearStatus();return true;\"\n"); //$NON-NLS-1$
				html.append("oncontextmenu=\"contextMenuHandler(event);return false;\"\n"); //$NON-NLS-1$
				html.append("title=\"" + UrlUtil.htmlEncode(bookmarks[i].getLabel()) + "\">\n"); //$NON-NLS-1$ //$NON-NLS-2$
				html.append(UrlUtil.htmlEncode(bookmarks[i].getLabel()) + "</a>\n"); //$NON-NLS-1$
				html.append("</td>\n"); //$NON-NLS-1$
				html.append("</tr>\n"); //$NON-NLS-1$
			}
			html.append("</table>\n"); //$NON-NLS-1$
			html.append("<div id=\"menu\">\n"); //$NON-NLS-1$
			
			String RemoveBookmarkString = ServletResources.getString(I18N.BOOKMARK_REMOVE,req);
			String RemoveAllBookmarksString = ServletResources.getString(I18N.BOOKMARK_REMOVE_ALL,req);
			
			html.append("<div class=\"unselectedMenuItem\" onmouseover=\"this.className='selectedMenuItem'\" onmouseout=\"this.className='unselectedMenuItem'\" onclick=\"removeBookmark()\" ><nobr>" + RemoveBookmarkString + "</nobr></div>\n"); //$NON-NLS-1$ //$NON-NLS-2$
			html.append("<div class=\"unselectedMenuItem\" onmouseover=\"this.className='selectedMenuItem'\" onmouseout=\"this.className='unselectedMenuItem'\" onclick=\"removeAllBookmarks()\" ><nobr>" + RemoveAllBookmarksString + "</nobr></div>\n"); //$NON-NLS-1$ //$NON-NLS-2$
			html.append("</div>\n"); //$NON-NLS-1$
			
		}
		html.append("</body>\n"); //$NON-NLS-1$
		html.append("</html>\n"); //$NON-NLS-1$
		String htmlString = html.toString();
		resp.getWriter().println(htmlString);
	}
}
