/*******************************************************************************
 * Copyright (c) 2004, 2005 IBM Corporation.
 * All rights reserved. 
 *******************************************************************************/
package com.ibm.samplesgallery.servlets;

import java.io.IOException;

import javax.servlet.ServletException; import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.ibm.samplegallery.internal.*;

/**
 * This class handles errors
 */
public class ErrorServlet extends HttpServlet implements GalleryConstants {
	
	/* (non-Javadoc)
	 * @see javax.servlet.http.HttpServlet#doGet(javax.servlet.http.HttpServletRequest, javax.servlet.http.HttpServletResponse)
	 */
	protected void doGet(HttpServletRequest req, HttpServletResponse res)
		throws ServletException, IOException {
		processRequest(req, res);
	}
	/* (non-Javadoc)
	 * @see javax.servlet.http.HttpServlet#doPost(javax.servlet.http.HttpServletRequest, javax.servlet.http.HttpServletResponse)
	 */
	protected void doPost(HttpServletRequest req, HttpServletResponse res)
		throws ServletException, IOException {
		processRequest(req, res);
	}

	private void processRequest(HttpServletRequest req, HttpServletResponse resp)
		throws ServletException, IOException {
		resp.setContentType("text/html;charset=UTF-8"); //$NON-NLS-1$
		String content = this.getAsHTML(req);
		resp.getWriter().println(content);
	}

	private String getAsHTML(HttpServletRequest req) {
		StringBuffer output = new StringBuffer();
		output.append("<html>\n"); //$NON-NLS-1$
		output.append("<head>\n"); //$NON-NLS-1$
		output.append("<link rel='stylesheet' href='topic/com.ibm.gallery.common/css/SamplesMaster.css'>\n"); //$NON-NLS-1$
		output.append("<title>");//$NON-NLS-1$
		output.append(ServletResources.getString(I18N.ERROR_GALLERY_TITLE, req));
		output.append("</title>\n");//$NON-NLS-1$
		output.append("</head>\n"); //$NON-NLS-1$
		output.append("<body class=\"category\">\n"); //$NON-NLS-1$
		output.append("<br>\n");//$NON-NLS-1$
		String errorStringKey = (String) req.getAttribute(RequestArguments.GALLERY_ERROR);
		String errorString = ServletResources.getString(errorStringKey, req);
		Object errorStringInfoObject = req.getAttribute(RequestArguments.GALLERY_ERROR_INFO_OBJECT);
		if (errorStringInfoObject != null) {
			String errorStringInfo = (String) errorStringInfoObject;
			output.append(errorString);
			output.append(errorStringInfo);
		} else {
			output.append(errorString);
		}
		output.append("<br>\n");//$NON-NLS-1$
		Object exception = req.getAttribute(RequestArguments.GALLERY_EXCEPTION);
		if (null != exception) {
			Exception e = (Exception) exception;
			output.append(e.getLocalizedMessage());
		}
		output.append("</body>\n"); //$NON-NLS-1$
		output.append("</html>\n"); //$NON-NLS-1$
		return (output.toString());
	}
}